
#include "c2.h"

/*
 * Try to fix up things of the form mov	di,ax; ... opr	XXX,di  into
 * opr  XXX,ax
 */
xmove(p)
register struct node *p;
{
	register struct node *p2,*p3;
	int src_set,dest_set,src,dest;

	if (p->op != MOV || p->regused == 0)
		return 0;
	dualop(p);
	if ( (src = isreg(regs[RT1])) < 0)
		return 0;
	if ( (dest = isreg(regs[RT2])) < 0)
		return 0;
	if (p->regset & ((017<<(regvar+1))&017))
		return 0;
/* printf("try 1\n"); */
	for (p2 = p->forw; p2; p2 = p2->forw) {
		if (p2->regset&p->regused)
			return 0;
		if (p2->regused&p->regset)
			break;
		if ( p2->op == LABEL )
			return 0;
	}
	if (p2 == NULL)
		return 0;
/* printf("found %d,%s\n", p2->op, p2->code); */
	/*
	 * We found a use. check forward for further use
	 * before reset.
	 */
	for ( p3 = src_set = dest_set = 0 
					; (src_set>=0||dest_set>=0) && p2 
								; p2 = p2->forw) {
		if ( p2->regused&p->regused ) {
			if ( dest_set )
				return 0;
			if ( !src_set )
				src_set = p2->regset&p->regused ;
		} else {
			if ( p2->regset&p->regused ) {
				src_set = -1;
				if ( p3 == 0 )
					p3 = p2; /* remember last inst to change */
			}
		}
		if ( p2->regused&p->regset ) {
			if ( src_set )
				return 0;
			if ( !dest_set )
				if ( dest_set = p2->regset&p->regset )
					if (p->regused & ((017<<(regvar+1))&017))
						return 0;
		} else {
			if ( p2->regset&p->regset ) {
				dest_set = -1;
				if ( p3 == 0 )
					p3 = p2; /* remember last inst to change */
			}
		}
		if ( p3 == 0 && chk_rep(p2,dest,src) )
			return 0;
#ifdef INTERMED
		if ( p2->op == JBR || p2->op == JMPI)
#else
		if ( p2->op == JBR )
#endif
			if ( dest_set == -1 )
				break;
			else
				return 0;
	}
/* printf("forw found %d, %s\n", p3->op, p3->code); */
	/*
	 * It appears that all uses of the destination of the move 
	 * can be replaced with the source of the move and
	 * the source is not used further forward if these changes
	 * will cause the source to be changed.
	 * Change the instructions and delete the move.
	 */
	for ( p2 = p->forw ; p2 != p3 ; p2 = p2->forw )
		repl_reg(p2,dest,src);
	p->forw->back = p->back;
	p->back->forw = p->forw;
	redunm++;
	nchange++;
	return 1;
}
